SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #OOStack
	instanceVariableNames: 'lastElement size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:19'!
initialize

	lastElement := EmptyStackElement new.
	size := 0.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:17'!
isEmpty
	^ lastElement isTheEmptyElement.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:13'!
pop
	
	| popElement |
	
	popElement := lastElement.
	
	lastElement :=  lastElement next.
	
	size := size - 1 .
	
	^ popElement data.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:19'!
push: aData

	| newElement |
	newElement := NotEmptyStackElement with: aData.
	newElement linkWith: lastElement.
	lastElement := newElement.
	size := size + 1.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:14'!
size

	^ size.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:14'!
top

	^ lastElement data.! !

Object subclass: #StackElement
	instanceVariableNames: 'nextElement data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

StackElement subclass: #EmptyStackElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!EmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:15'!
data

	^ Error signal: OOStack stackEmptyErrorDescription.! !

!EmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:17'!
isTheEmptyElement

	^ true.! !

!EmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:03'!
linkWith: anElement

	^ Error signal: OOStack stackEmptyErrorDescription.
	! !

!EmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 20:47'!
next

	^ Error signal: OOStack stackEmptyErrorDescription.! !

StackElement subclass: #NotEmptyStackElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!NotEmptyStackElement class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:00'!
with: aData

	^self new initializeWith: aData.! !

!NotEmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:06'!
data

	^ data.! !

!NotEmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:00'!
initializeWith: aData

	data := aData.

	! !

!NotEmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:17'!
isTheEmptyElement

	^ false.	! !

!NotEmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:04'!
linkWith: anElement

	nextElement := anElement.! !

!NotEmptyStackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 20:49'!
next

	^ nextElement.! !

!StackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:05'!
data

	^ self subclassResponsibility .! !

!StackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:17'!
isTheEmptyElement

	^ self subclassResponsibility.! !

!StackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 21:01'!
linkWith: anElement

	self subclassResponsibility .! !

!StackElement methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/14/2012 20:45'!
next

	^ self subclassResponsibility.! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:39'!
test09CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
